using System;
namespace drugi_zadatak_kvalifikacije_2024_plazma_
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] linija = Console.ReadLine().Split(' ');
            int N = int.Parse(linija[0]);
            int Q = int.Parse(linija[1]);

            long[] d = new long[N];
            long[] p = new long[N];
        
            for (int i = 0; i < N; i++)
            {
                string[] linija2 = Console.ReadLine().Split(' ');
                d[i] = long.Parse(linija2[0]);
                p[i] = long.Parse(linija2[1]);
            }
            long[] k = new long[Q];
            for (int j = 0; j < Q; j++)
            {
                k[j] = long.Parse(Console.ReadLine());
            }

            Array.Sort(d);
            Array.Sort(p);
            Array.Sort(k);

            long pakovanje = 0;
            for(int i = 0; i < Q; i++)
            {
                long plazma = 0;
                for (int j = 0; j < N; j++)
                {
                    if (d[j] > k[i])
                    {
                        break;
                        
                    }
                    else  
                    { 
                        if(p[j] <= k[i] - d[j])
                        {
                            pakovanje = p[j];
                        }
                        else if (p[j] > k[i] - d[j])
                        {
                            pakovanje = k[i] - d[j] + 1;
                            
                        }
                        plazma += pakovanje;
                    }
                }
                Console.WriteLine(plazma);
            }
            


        }
    }
}